<?php

/****************************************************************************

  Copyright (C) 2017-2020  Sendatel S.A.

  This file is part of TUIDD Wordpress SDK.
  TUIDD Wordpress SDK is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  TUIDD Wordpress SDK is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TUIDD Wordpress SDK.  If not, see <http://www.gnu.org/licenses/>.

****************************************************************************/

/**
 * @package tuidd
 * @version 2.0.0
 */
/*
  Plugin Name: tuidd Log-in integration
  Plugin URI: http://wordpress.org/plugins/tuidd
  Text Domain: tuidd-plugin
  Domain Path: /languages
  Description: This module allows to generate an authentication mechanism through mobile connect integration with Wordpress
  Author: Tuidd
  Version: 1.0
  Author URI: Tuidd
*/

function tuidd_settings()
{
	// CLIENT ID
	add_option( 'tuidd_option_client_id', 'lNqMeRl8smlXUdDCcl28XkrMrL5fSzp5');
	register_setting( 'tuidd_options_group', 'tuidd_option_client_id' );
	
	// SECRET
	add_option( 'tuidd_option_secret', '302256985452112');
	register_setting( 'tuidd_options_group', 'tuidd_option_secret' );
	
	// REDIRECT URI
	add_option( 'tuidd_option_redirect_uri', home_url().'/wp-content/plugins/tuidd/index.php');
	register_setting( 'tuidd_options_group', 'tuidd_option_redirect_uri' );
	
	// // AUTHORIZED REDIRECT URI
	// add_option( 'tuidd_option_authorized_redirect_uri', 'http://192.168.124.200/wordpress/');
	// register_setting( 'tuidd_options_group', 'tuidd_option_authorized_redirect_uri', 'myplugin_callback' );
	
	// HOME PAGE URL
	add_option( 'tuidd_option_home_page_url', home_url());
	register_setting( 'tuidd_options_group', 'tuidd_option_home_page_url' );

	// HOME PAGE RESULT LOGUN URL
	add_option( 'tuidd_option_home_result_login_url', home_url());
	register_setting( 'tuidd_options_group', 'tuidd_option_home_login_url' );

	// SCOPE
	add_option( 'tuidd_option_scope', 'openid profile email phone survey publicity');
	register_setting( 'tuidd_options_group', 'tuidd_option_scope' );
	
	// SECURITY
	add_option( 'tuidd_option_security_level', '3 2');
	register_setting( 'tuidd_options_group', 'tuidd_option_security_level' );
	
	// PAYMENT TOKEN
	add_option( 'tuidd_option_payment_token', 'c333504b-953d-4a2f-b82c-d3584d030f2b');
	register_setting( 'tuidd_options_group', 'tuidd_option_payment_token' );

	// SAVE USER INFO
	add_option( 'tuidd_option_save_userinfo', 1);
	register_setting( 'tuidd_options_group', 'tuidd_option_save_userinfo' );

	// EXECUTE CUSTOM CALLBACK
	add_option( 'tuidd_option_execute_callback', 1);
	register_setting( 'tuidd_options_group', 'tuidd_option_execute_callback' );

	// EXECUTE STATE NONCE CALLBACK
	add_option( 'tuidd_option_state_nonce_callback', 1);
	register_setting( 'tuidd_options_group', 'tuidd_option_state_nonce_callback' );

	// DEBUG INFORMATION 
	add_option( 'tuidd_option_debug', 1);
	register_setting( 'tuidd_options_group', 'tuidd_option_debug' );


	// DEBUG INFORMATION 
	add_option( 'tuidd_option_serivces_notif_callback_function', '');
	register_setting( 'tuidd_options_group', 'tuidd_option_serivces_notif_callback_function' );

	// // CALLBACK FUNCTION
	// add_option( 'tuidd_option_callback_function', 'process_info');
	// register_setting( 'tuidd_options_group', 'tuidd_option_callback_function', 'myplugin_callback' );

	// // CALLBACK FUNCTION FILE
	// add_option( 'tuidd_option_callback_function_file', '');
	// register_setting( 'tuidd_options_group', 'tuidd_option_callback_function_file', 'myplugin_callback' );

	// // CONTAINER DIV
	// add_option( 'tuidd_option_container_div', 'tuidd-sdk');
	// register_setting( 'tuidd_options_group', 'tuidd_option_container_div', 'myplugin_callback' );
}
add_action( 'admin_init', 'tuidd_settings' );


function tuidd_register_options_page()
{
    add_options_page('Tuidd Configuration', 'Tuidd Configuration', 'manage_options', 'Tuidd', 'tuidd_options_page');
}
add_action('admin_menu', 'tuidd_register_options_page');


function tuidd_options_page()
{
?>
    <div>
	<?php screen_icon(); ?>
	<h2>Tuidd Configuration</h2>
	<form method="post" action="options.php">
	    <?php settings_fields( 'tuidd_options_group' ); ?>
	    <table class="settings-table">	  
		
		<tr>
		    <th scope="row"><label for="tuidd_option_client_id">Client ID:</label></th>
		    <th><input type="text" id="tuidd_option_client_id" name="tuidd_option_client_id" value="<?php echo get_option('tuidd_option_client_id'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: 73958620d779-4fdc-bc09-7d521af91278<br>
			Ese el ID de la aplicación generado durante el registro en el sitio de<br>
			en el sitio de gestión de Tuidd.</p></td>
		</tr>
		
		<tr>
		    <th scope="row"><label for="tuidd_option_secret">Client Secret:</label></th>
		    <th><input type="text" id="tuidd_option_secret" name="tuidd_option_secret" value="<?php echo get_option('tuidd_option_secret'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: 45759620e745-4adb-b329-5d521af3433<br>
			Es la clave que se asignó automáticamente a la aplicación durante el registro<br>
			gestión de Tuidd.</p></td>
		</tr>


		<tr>
		    <th scope="row"><label for="tuidd_option_home_page_url">Home Page URL:</label></th>
		    <th><input type="text" id="tuidd_option_home_page_url" name="tuidd_option_home_page_url" value="<?php echo get_option('tuidd_option_home_page_url'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p> Ejemplo: http://ejemplo.com<br>
			Esta URL es la que utiliza el SDK para redirigir automáticamente<br>
			cuando se llama a la función isLoggedIn(). </p></td>
		</tr> 
		

		<tr>
		    <th scope="row"><label for="tuidd_option_home_login_url">Result Login URL:</label></th>
		    <th><input type="text" id="tuidd_option_home_login_url" name="tuidd_option_home_login_url" value="<?php echo get_option('tuidd_option_home_login_url'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: http://ejemplo.com/admin<br>
			Es la URI a la cual se va a redirigir al usuario al finalizar el proceso de<br>
			autenticación ya sea de que falle o no. En caso de falla, la URI contendrá<br>
			el código de error y el detalle como parámetros adicionales. Ver Integración<br>
			del botón de Login.</p></td>
		</tr> 
		
		<tr>
		    <th scope="row"><label for="tuidd_option_redirect_uri">Redirect URI:</label></th>
		    <th><input type="text" id="tuidd_option_redirect_uri" name="tuidd_option_redirect_uri" value="<?php echo get_option('tuidd_option_redirect_uri'); ?>" readonly/></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: http://mysite.com/tuidd/<br>
			URI donde se procesa el resultado de la autenticación.<br>
			Este parametro debe estar vacío salvo que no se quiera que el SDK realice el<br>
			procesamiento por defecto. Si se modifica esta URI debe modificarse también<br>
			el registro en el sitio de administración.</p></td>
		</tr> 
		<!-- <th scope="row"><label for="tuidd_option_authorized_redirect_uri">Authorized Redirect Uri</label></th>
		     <td><input type="text" id="tuidd_option_authorized_redirect_uri" name="tuidd_option_authorized_redirect_uri" value="<?php /*echo get_option('tuidd_option_authorized_redirect_uri'); */ ?>"/></td>
		     </tr> -->
		

		<tr>
		    <th scope="row"><label for="tuidd_option_scope">Scope:</label></th>
		    <th><input type="text" id="tuidd_option_scope" name="tuidd_option_scope" value="<?php echo get_option('tuidd_option_scope'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: openid profile <br>
			Lista de strings ASCII "case-sensitive" con valores de "scope" del estándar<br>
			OAuth 2.0.<br>
			Según el estándar debe contener el valor "openid".<br>
			Otros valores posibles son: profile, email, address, phone, offline_access,<br>
			tuidd_notification, tuidd_advertising, tuidd_survey, tuidd_payment, tuidd_coupon.</p></td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_security_level">ACR Values:</label></th>
		    <th><input type="text" id="tuidd_option_security_level" name="tuidd_option_security_level" value="<?php echo get_option('tuidd_option_security_level'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: 3 2<br>
			Son los valores de LOAs requeridos por la aplicación, en orden de <br>
			preferencia, de acuerdo a la norma ISO/IEC 29115 Clause 6 – 1, 2, 3, 4 – <br>
			representando los niveles LOW, MEDIUM, HIGH y VERY HIGH.<br>
			Tener en cuenta que Tuidd actualmente sólo soporta los valores 2 y 3. <br>
			El valor finalmente utilizado es devuelto en el campo “acr” en la <br>
			autenticación.</p></td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_payment_token">Payment Token:</label></th>
		    <th><input type="text" id="tuidd_option_payment_token" name="tuidd_option_payment_token" value="<?php echo get_option('tuidd_option_payment_token'); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: c333504b-953d-4a2f-b82c-d3584d030f2b<br>
			Es el valor del token para consumir el servicio de Pagos, asignado<br>
			automáticamente a la aplicación al momento del registro.</p></td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_save_userinfo">Guardar Información de Usuario:</label></th>
		    <th><input type="checkbox" id="tuidd_option_save_userinfo" name="tuidd_option_save_userinfo" value='1' "<?php echo checked(get_option('tuidd_option_save_userinfo')==1); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: 1<br>
			Luego de autorizar el usuario mediante tuidd sea crea uno en Wordpress.<br>
			con la información de tuidd. Valor 1 habilita esta opción. 0 deshabilita.</p>
		    </td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_execute_callback">Ejecutar callback customizada:</label></th>
		    <th><input type="checkbox" id="tuidd_option_execute_callback" name="tuidd_option_execute_callback" value='1' "<?php echo checked(get_option('tuidd_option_execute_callback')==1); ?>" /></th>
		</tr>
		<tr>
		    <td colspan=2><p>Ejemplo: 1<br>
			Para desarrolladores avanzados, se puede habilitar esta opción, permitiendo <br>
			hacer un proceso customizado de la información de usuario.</p></p></td>
		</tr> 
		<!-- 	  <tr>
		     <th scope="row"><label for="tuidd_option_callback_function">Function Callback</label></th>
		     <td><input type="text" id="tuidd_option_callback_function" name="tuidd_option_callback_function" value="<?php /*echo get_option('tuidd_option_callback_function'); */ ?>" /></td>
		     </tr>
		     <tr>
		     <th scope="row"><label for="tuidd_option_container_div">Container Div</label></th>
		     <td><input type="text" id="tuidd_option_container_div" name="tuidd_option_container_div" value="<?php /*echo get_option('tuidd_option_container_div'); */ ?>" /></td>
		     </tr> -->

  		<tr>
		    <th scope="row"><label for="tuidd_option_state_nonce_callback">State and Nonce Callback</label></th>
		    <td><input type="text" id="tuidd_option_state_nonce_callback" name="tuidd_option_state_nonce_callback" value="<?php echo get_option('tuidd_option_state_nonce_callback'); ?>" /></td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_services_notif_callback_function">Services Notification Callback Function</label></th>
		    <td><input type="text" id="tuidd_option_services_notif_callback_function" name="tuidd_option_services_notif_callback_function" value="<?php echo get_option('tuidd_option_services_notif_callback_function'); ?>" /></td>
		</tr> 

		<tr>
		    <th scope="row"><label for="tuidd_option_debug">Debug Information:</label></th>
		    <th><input type="checkbox" id="tuidd_option_debug" name="tuidd_option_debug" value='1' "<?php echo checked(get_option('tuidd_option_debug')==1); ?>" /></th>
		</tr>
		
	    </table>
	    
	    <?php submit_button(); ?>
	</form>
    </div>
<?php
} 


function tuidd_load_textdomain()
{
	load_plugin_textdomain( 'tuidd-plugin', false, dirname( plugin_basename(__FILE__) ) . '/languages/' );
}
add_action('plugins_loaded', 'tuidd_load_textdomain');


function add_theme_scripts()
{
    $internal_conf = parse_ini_file( 'libs/tuidd_lib/client/internal_params.conf' );
    $url_discovery = $internal_conf['tuidd_sdk'];
    $pcrValue = $_COOKIE['pcr'];

    wp_enqueue_script( 'jquery-js', 'https://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js', '', 1.1
                     , true);
    wp_enqueue_script( 'onw-jquery-js', plugins_url( 'pub/js/own_jquery.js' , __FILE__ ), array ( 'jquery-js' ), 1.1, true);  
    wp_enqueue_script( 'intlTelInput-js', plugins_url( 'pub/js/intl-tel-input/build/js/intlTelInput.js' , __FILE__ ), array ( 'jquery' ), 1.1, true);
    wp_enqueue_script( 'cookie-js', plugins_url( 'pub/js/jquery-cookie/jquery.cookie.js' , __FILE__ ), array ( 'jquery' ), 1.1, true);
    wp_enqueue_script( 'tuidd-js', $url_discovery . '/js/jsButtonWidget.js', array ( 'jquery' ), 1.1, true);
    wp_enqueue_script( 'carousel-js', $url_discovery . '/js/carousel.min.js', array ( 'jquery' ), 1.1, true );

    wp_enqueue_style( 'font-css', plugins_url( 'pub/css/sdk.css' , __FILE__ ) );
    wp_enqueue_style( 'intlTelInput-css', plugins_url( 'pub/js/intl-tel-input/build/css/intlTelInput.css' , __FILE__ ) );
    wp_enqueue_style( 'carousel-css', $url_discovery . '/css/carousel.min.css' );
    wp_enqueue_style( 'tuidd-css', $url_discovery . '/css/tuidd.min.css' );

    wp_localize_script( 'tuidd-js', 'sdk_properties', array(
	'type' => 'wp',
	'url' => get_site_url(),
	'ajax_url' => admin_url( 'admin-ajax.php' ),
	'plugin_url' => plugin_dir_url( __FILE__ ),
	'lang' => array( 'wrong_number' => __('Invalid number', 'tuidd-plugin')),
	'callback' => 'tuidd_process_requests',
	'pcrValue' => $pcrValue,
    ));	

}
add_action( 'wp_enqueue_scripts', 'add_theme_scripts' );


class TuiddWidget extends WP_Widget
{
    function TuiddWidget()
    {
        $widget_ops = array('classname' => 'TuiddWidget', 'description' => 'Tuidd integration' );
        $this->WP_Widget('TuiddWidget', 'Tuidd Integration', $widget_ops);
        add_theme_scripts();
    }
 

    function form($instance)
    {
        $instance = wp_parse_args( (array) $instance, array( 'title' => '' ) );
        $title = $instance['title'];
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>">Title: <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" /></label></p>
<?php
    }
 

    function update($new_instance, $old_instance)
    {
        $instance = $old_instance;
        $instance['title'] = $new_instance['title'];
        return $instance;
    }
 

    function widget($args, $instance)
    {
        extract($args, EXTR_SKIP);
 
        echo $before_widget;
        $title = empty($instance['title']) ? ' ' : apply_filters('widget_title', $instance['title']);
 
        if (!empty($title))
            echo $before_title . $title . $after_title;;
 
        if (! is_user_logged_in())
        {
            echo '<div id="tuidd-wrapper"></div>';
        }
        echo $after_widget;
    }
 
}
add_action( 'widgets_init', create_function('', 'return register_widget("TuiddWidget");') );


function tuidd_init_session()
{
    require_once( plugin_dir_path( __FILE__ ) . 'libs/tuidd_lib/client/TuiddClient.php' ); 
    session_name('sdk-session');
    session_start();
    session_name('sdk-session');
}
add_action('init', 'tuidd_init_session', 1);


function sess_start()
{
    if (!session_id()) {
        session_name('sdk-session');
        session_start();
    }
}
add_action('init','sess_start');


/**
 * Define the action and give functionality to the action.
 */
function tuidd_action() {
    do_action( 'tuidd_action' );
}
 

/**
 * Register the action with WordPress.
 */
add_action( 'tuidd_action', 'tuidd_action_callback_function' );


function get_client_ip()
{
    $ipaddress = '';
    if (isset($_SERVER['HTTP_CLIENT_IP']))
        $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
    else if(isset($_SERVER['HTTP_X_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_X_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
    else if(isset($_SERVER['HTTP_FORWARDED_FOR']))
        $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
    else if(isset($_SERVER['HTTP_FORWARDED']))
        $ipaddress = $_SERVER['HTTP_FORWARDED'];
    else if(isset($_SERVER['REMOTE_ADDR']))
        $ipaddress = $_SERVER['REMOTE_ADDR'];
    else
        $ipaddress = 'UNKNOWN';
    return $ipaddress;
}


function tuidd_process_requests() 
{
    tuidd_init_session();	
    
    $action = (isset($_GET['post_var']) ? $_GET['post_var'] : 'bla');

    switch ($action) 
    {
	case 'loadbutton':
        $tuidd = TuiddClient::getSingleton();
	
        $client_id      = $tuidd->getClientID();
        $scope          = $tuidd->getScope();
        $acr_values     = $tuidd->getSecurityLevel();
        $redirect_uri   = $tuidd->getRedirectURI();

        $response_type = 'code';
        $display = 'page';
        $locale = 'en_US';

        // Se llama a la funcion de callback establecida en archivo de config
        // para generar state y nonce
        $tuidd->generateStateAndNonce();

        // Se refresca la sesion
        $tuidd = TuiddClient::getSingleton(); 
        $state = $tuidd->getState();
        $nonce = $tuidd->getNonce();

        $urlRequest = '{request_url}' . 
                      '?client_id=' . $client_id . 
                      '&response_type=' . $response_type . 
                      '&scope=' . $scope .
                      '&redirect_uri=' . $redirect_uri .
                      '&acr_values=' . $acr_values;

        if ( $state != '') {
            $urlRequest = $urlRequest . '&state=' . $state;
        } else { $urlRequest = $urlRequest . '&state=state'; }
        if ( $nonce != '') {
            $urlRequest = $urlRequest . '&nonce=' . $nonce;
        } else { $urlRequest = $urlRequest . '&nonce=nonce'; }
        $urlRequest = $urlRequest .
                      '&display=' . $display .
                      '&ui_locales=' . $locale;

        $login_without_pass = __( 'Log in withouth Password', 'tuidd-plugin' );
        $login_button = __( 'Log In', 'tuidd-plugin' );

        $phone_number = __( 'Please, select your country and enter your phone number', 'tuidd-plugin'); 
        $login = __( 'Log In', 'tuidd-plugin');
        $recover_pass = __( 'Recover Password', 'tuidd-plugin');
        $login_mcg = __( "Try login with MCG, it's more easy and secure", 'tuidd-plugin');
        $have_no_account = __( 'I have no account', 'tuidd-plugin');

        $mobile_connect_login = __( 'MOBILE CONNECT LOGIN', 'tuidd-plugin');
        $u_dont_have_account = __( "You don't have account", 'tuidd-plugin');
        $know_advantages = __( 'Know the benefits', 'tuidd-plugin');
	
        $create_account = __( 'Create Account', 'tuidd-plugin');
        $advantages = __( 'Tuidd Connect Offers', 'tuidd-plugin');

        $more_info = __( 'More info', 'tuidd-plugin');
        $convinient = __( 'Simplicity', 'tuidd-plugin');
        $privacy = __( 'Privacy', 'tuidd-plugin');
        $security = __( 'Security', 'tuidd-plugin');

        $more_security = __( 'You can access to sites securly without passwords using your phone', 'tuidd-plugin');
        $one_way_login = __( "You don\'t need multiples passwords or usernames", 'tuidd-plugin');
        $personal_info = __( 'Your personal information is never shared without your concent', 'tuidd-plugin');

        $wrapper = curl_file_get_contents(  $tuidd->getTuiddContentURL() . '/html/sdk-wrapper'  );
        $tuidd_sdk_path = plugin_dir_url( __FILE__ );
        $inputMsisdn = '';
	
        $wrapper = str_replace("{request}", $urlRequest, $wrapper);
        $wrapper = str_replace("{msisdn}", $inputMsisdn, $wrapper);
        $wrapper = str_replace("{login_without_pass}", $login_without_pass, $wrapper);
        $wrapper = str_replace("{phone_number}", $phone_number, $wrapper);
        $wrapper = str_replace("{login_button}", $login_button, $wrapper);
        $wrapper = str_replace("{have_no_account}", $have_no_account, $wrapper);
        $wrapper = str_replace("{security}", $security, $wrapper);
        $wrapper = str_replace("{more_security}", $more_security, $wrapper);
        $wrapper = str_replace("{privacy}", $privacy, $wrapper);
        $wrapper = str_replace("{more_info}", $more_info, $wrapper);
        $wrapper = str_replace("{tuidd_sdk_path}", $tuidd->getTuiddContentURL() . '/css/', $wrapper);
        $wrapper = str_replace("{convinient}", $convinient, $wrapper);
        $wrapper = str_replace("{one_way_login}", $one_way_login, $wrapper);
        $wrapper = str_replace("{create_account}", $create_account, $wrapper);
        $wrapper = str_replace("{personal_info}", $personal_info, $wrapper);
        $wrapper = str_replace("{advantages}", $advantages, $wrapper);
        $wrapper = str_replace('\"', '"', $wrapper);

        echo $wrapper;
        break;

	case 'login':
        $tuidd = TuiddClient::getSingleton();
        break;

	case 'discovery':
        $tuidd = TuiddClient::getSingleton();
        $url = $tuidd->discovery();
        echo '(' . "{'request_url' : '" . $url . "' }". ')';
        break;

	default:
        echo header( "location:".home_site_url() );
        break;	
    }
    die();
}
add_action('wp_ajax_nopriv_tuidd_process_requests', 'tuidd_process_requests');
add_action('wp_ajax_tuidd_process_requests', 'tuidd_process_requests');


// CALLBACK FUNCTION
function tuidd_action_callback_function()
{
    echo 'tuidd_callback';
}


// CALLBACK FUNCTION
function stateNonceCallbackFunction()
{
    $tuidd = TuiddClient::getSingleton();

    $timestamp = time();
    $state = hash('sha256', $tuidd->getClientID() . $timestamp);
    $tuidd->setState( $state );

    $nonce = hash('sha256', get_client_ip() . $timestamp);
    $tuidd->setNonce( $nonce );
}


function curl_file_get_contents($file)
{
    if (function_exists('curl_version'))
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $file);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);

        $content = curl_exec($curl);
        curl_close($curl);
    }
    else if (file_get_contents(__FILE__) && ini_get('allow_url_fopen'))
    {
        $arrContextOptions=array(
            "ssl"=>array(
                "verify_peer"=>false,
                "verify_peer_name"=>false,
            ),
        ); 
        $content = file_get_contents($file, false, stream_context_create($arrContextOptions));
    }
    else
    {
        echo 'You have neither cUrl installed nor allow_url_fopen activated. Please setup one of those!';
    }
    return $content;
}

?>
